VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmMain 
   Caption         =   "VB6 Regular Expressions Tester"
   ClientHeight    =   6015
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9870
   LinkTopic       =   "Form1"
   ScaleHeight     =   6015
   ScaleWidth      =   9870
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fResults 
      Caption         =   "Results"
      Height          =   3675
      Left            =   105
      TabIndex        =   9
      Top             =   2265
      Width           =   9645
      Begin VB.CommandButton cmdClear 
         Caption         =   "&Clear"
         Height          =   330
         Left            =   8415
         TabIndex        =   18
         Top             =   3285
         Width           =   1080
      End
      Begin RichTextLib.RichTextBox rtbResults 
         Height          =   2940
         Left            =   135
         TabIndex        =   10
         Top             =   270
         Width           =   9375
         _ExtentX        =   16536
         _ExtentY        =   5186
         _Version        =   393217
         BorderStyle     =   0
         Enabled         =   -1  'True
         ScrollBars      =   2
         TextRTF         =   $"frmMain.frx":0000
      End
   End
   Begin VB.Frame fRegExp 
      Caption         =   "Regular Expression"
      Height          =   2130
      Left            =   105
      TabIndex        =   0
      Top             =   60
      Width           =   9660
      Begin VB.TextBox txtReplaceWith 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1335
         TabIndex        =   16
         Top             =   1245
         Width           =   8175
      End
      Begin VB.PictureBox picActions 
         BorderStyle     =   0  'None
         Height          =   360
         Left            =   5040
         ScaleHeight     =   360
         ScaleWidth      =   4485
         TabIndex        =   11
         Top             =   1650
         Width           =   4485
         Begin VB.CommandButton cmdExecute 
            Caption         =   "&Execute"
            Height          =   330
            Left            =   780
            TabIndex        =   14
            Top             =   15
            Width           =   1080
         End
         Begin VB.CommandButton cmdReplace 
            Caption         =   "&Replace"
            Height          =   330
            Left            =   2077
            TabIndex        =   13
            Top             =   15
            Width           =   1080
         End
         Begin VB.CommandButton cmdTest 
            Caption         =   "&Test"
            Height          =   330
            Left            =   3375
            TabIndex        =   12
            Top             =   15
            Width           =   1080
         End
         Begin VB.Label lblActions 
            Caption         =   "Actions:"
            Height          =   255
            Left            =   0
            TabIndex        =   15
            Top             =   75
            Width           =   1290
         End
      End
      Begin VB.CheckBox chbIgnoreCase 
         Caption         =   "IgnoreCase"
         Height          =   225
         Left            =   3225
         TabIndex        =   7
         Top             =   1725
         Width           =   1350
      End
      Begin VB.CheckBox chbMultiline 
         Caption         =   "Multiline"
         Height          =   225
         Left            =   2235
         TabIndex        =   6
         Top             =   1725
         Width           =   900
      End
      Begin VB.CheckBox chbGlobal 
         Caption         =   "Global"
         Height          =   225
         Left            =   1350
         TabIndex        =   5
         Top             =   1725
         Width           =   900
      End
      Begin VB.TextBox txtSourceString 
         Alignment       =   1  'Right Justify
         Height          =   285
         Left            =   1335
         TabIndex        =   4
         Top             =   825
         Width           =   8175
      End
      Begin VB.TextBox txtExpression 
         Alignment       =   1  'Right Justify
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   9
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   285
         Left            =   1335
         TabIndex        =   1
         Top             =   405
         Width           =   8175
      End
      Begin VB.Label lblReplaceWith 
         Caption         =   "Replace with:"
         Height          =   255
         Left            =   195
         TabIndex        =   17
         Top             =   1290
         Width           =   1290
      End
      Begin VB.Label lblOptions 
         Caption         =   "Options:"
         Height          =   255
         Left            =   195
         TabIndex        =   8
         Top             =   1725
         Width           =   1290
      End
      Begin VB.Label lblSourceString 
         Caption         =   "Source string:"
         Height          =   255
         Left            =   195
         TabIndex        =   3
         Top             =   862
         Width           =   1290
      End
      Begin VB.Label lblExpression 
         Caption         =   "Expression:"
         Height          =   255
         Left            =   195
         TabIndex        =   2
         Top             =   435
         Width           =   1290
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Enum RichStyles
    Normal = 0
    Italic = 1
    Bold = 2
    Underline = 4
    Monospace = 8
End Enum
'

Private Sub cmdClear_Click()
    
    rtbResults.Text = vbNullString
    
End Sub
'

' Execute metoda
Private Sub cmdExecute_Click()

    On Error GoTo hell
    
    Dim oRegExp     As RegExp
    Dim oMatches    As MatchCollection
    Dim oMatch      As Match
    Dim oSubMatches As SubMatches
    
    Dim lIndex      As Long
    
    ' prvo da proverimo da li su uneti potrebni podaci
    If LenB(txtExpression) = 0 Then
        MsgBox "You must enter regular expression.", vbExclamation, "Error"
        txtExpression.SetFocus
        Exit Sub
    End If
    
    If LenB(txtSourceString) = 0 Then
        MsgBox "You must enter source string.", vbExclamation, "Error"
        txtSourceString.SetFocus
        Exit Sub
    End If
    
    ' kreiramo novi RegExp objekat
    Set oRegExp = New RegExp
    
    ' podesavamo regularni izraz
    oRegExp.Pattern = txtExpression.Text
    
    ' podesavamo opcije
    oRegExp.Global = chbGlobal.Value
    oRegExp.MultiLine = chbMultiline.Value
    oRegExp.IgnoreCase = chbIgnoreCase.Value
    
    ' izrsavamo regularni izraz
    Set oMatches = oRegExp.Execute(txtSourceString.Text)
    
    ' upisujemo regularni izraz u rich text box
    AppendRichText vbNewLine & "Expression: "
    AppendRichTextLn txtExpression.Text & vbNewLine, vbBlue, Monospace Or Italic
    
    ' upisujemo source string
    AppendRichText "Source string: "
    AppendRichTextLn txtSourceString.Text & vbNewLine, RGB(64, 0, 0), Bold
    
    If oMatches.Count = 0 Then
    
        AppendRichTextLn " - No matches found."
    
    Else
        
        AppendRichText " Found "
        AppendRichText oMatches.Count, , Bold
        AppendRichTextLn " match(es):"
        
        For Each oMatch In oMatches
            With oMatch
                
                ' Value
                AppendRichTextLn "    " & .Value, RGB(0, 128, 0), Monospace Or Italic
                
                ' FirstIndex
                AppendRichText "    " & " FirstIndex: "
                AppendRichTextLn .FirstIndex, RGB(128, 0, 0), Bold Or Monospace
                
                ' Length
                AppendRichText "    " & " Length: "
                AppendRichTextLn .Length, RGB(128, 0, 0), Bold Or Monospace
                
                'SubMatches
                Set oSubMatches = .SubMatches
                
                AppendRichText "    " & " SubMatches: "
                AppendRichTextLn oSubMatches.Count, RGB(128, 0, 0), Bold Or Monospace
                
                For lIndex = 0 To oSubMatches.Count - 1
                    AppendRichText "        " & lIndex, RGB(128, 0, 0), Bold Or Monospace
                    AppendRichTextLn " " & oSubMatches(lIndex), RGB(0, 128, 0), Monospace
                Next
            
            End With
            
            AppendRichTextLn " " & String(80, "-")
            
        Next
        
        AppendRichTextLn " " & String(80, "-")
    
    End If
    
    Exit Sub
hell:
    MsgBox Err.Description, vbCritical, "Error [" & Err.Source & ": " & Err.Number & "]"
    Err.Clear
End Sub
'

' Replace metoda
Private Sub cmdReplace_Click()
    On Error GoTo hell
    
    Dim oRegExp     As RegExp
    Dim sResult     As String
    
    ' prvo da proverimo da li su uneti potrebni podaci
    If LenB(txtExpression) = 0 Then
        MsgBox "You must enter regular expression.", vbExclamation, "Error"
        txtExpression.SetFocus
        Exit Sub
    End If
    
    If LenB(txtSourceString) = 0 Then
        MsgBox "You must enter source string.", vbExclamation, "Error"
        txtSourceString.SetFocus
        Exit Sub
    End If
    
    ' kreiramo novi RegExp objekat
    Set oRegExp = New RegExp
    
    ' podesavamo regularni izraz
    oRegExp.Pattern = txtExpression.Text
    
    ' podesavamo opcije
    oRegExp.Global = chbGlobal.Value
    oRegExp.MultiLine = chbMultiline.Value
    oRegExp.IgnoreCase = chbIgnoreCase.Value
    
    ' izvrsavamo regexp replace
    sResult = oRegExp.Replace(txtSourceString.Text, txtReplaceWith.Text)
    
    ' upisujemo regularni izraz u rich text box
    AppendRichText vbNewLine & "Expression: "
    AppendRichTextLn txtExpression.Text & vbNewLine, vbBlue, Monospace Or Italic
    
    ' upisujemo source string
    AppendRichText "Source string: "
    AppendRichTextLn txtSourceString.Text & vbNewLine, RGB(64, 0, 0), Bold
    
    ' upisujemo replace with string
    AppendRichText "Replace with: "
    AppendRichTextLn txtReplaceWith.Text & vbNewLine, RGB(0, 128, 0), Bold
    
    ' upisujemo rezultat
    AppendRichText "Result: "
    AppendRichTextLn sResult & vbNewLine, RGB(128, 0, 0), Italic Or Monospace
    
    AppendRichTextLn " " & String(80, "-") ' separator
    
    Exit Sub
hell:
    MsgBox Err.Description, vbCritical, "Error [" & Err.Source & ": " & Err.Number & "]"
    Err.Clear
End Sub
'

' Test metoda
Private Sub cmdTest_Click()
    
    On Error GoTo hell
    
    Dim oRegExp     As RegExp
    Dim bResult     As Boolean
    
    ' prvo da proverimo da li su uneti potrebni podaci
    If LenB(txtExpression) = 0 Then
        MsgBox "You must enter regular expression.", vbExclamation, "Error"
        txtExpression.SetFocus
        Exit Sub
    End If
    
    If LenB(txtSourceString) = 0 Then
        MsgBox "You must enter source string.", vbExclamation, "Error"
        txtSourceString.SetFocus
        Exit Sub
    End If
    
    ' kreiramo novi RegExp objekat
    Set oRegExp = New RegExp
    
    ' podesavamo regularni izraz
    oRegExp.Pattern = txtExpression.Text
    
    ' podesavamo opcije
    oRegExp.Global = chbGlobal.Value
    oRegExp.MultiLine = chbMultiline.Value
    oRegExp.IgnoreCase = chbIgnoreCase.Value
    
    ' izvrsavamo test
    bResult = oRegExp.Test(txtSourceString.Text)
    
    ' upisujemo regularni izraz u rich text box
    AppendRichText vbNewLine & "Expression: "
    AppendRichTextLn txtExpression.Text & vbNewLine, vbBlue, Monospace Or Italic
    
    ' upisujemo source string
    AppendRichText "Source string: "
    AppendRichTextLn txtSourceString.Text & vbNewLine, RGB(64, 0, 0), Bold

    ' upisujemo rezultat
    AppendRichText "Test: "
    If bResult Then
        AppendRichTextLn "Success" & vbNewLine, RGB(0, 128, 0), Monospace Or Italic
    Else
        AppendRichTextLn "Failed" & vbNewLine, RGB(255, 0, 0), Monospace Or Italic Or Bold
    End If
    
    AppendRichTextLn " " & String(80, "-") ' separator
    
    Exit Sub
hell:
    MsgBox Err.Description, vbCritical, "Error [" & Err.Source & ": " & Err.Number & "]"
    Err.Clear
End Sub
'

' dodaje text u richtextbox i formatira ga
Private Sub AppendRichText(sText As String, _
                            Optional color As Long = vbBlack, _
                            Optional style As RichStyles = Normal)
    
    Dim iStart  As Long
    
    With rtbResults
        
        iStart = Len(.Text) + 1
        
        .SelStart = iStart
        .SelLength = Len(sText)
        .SelColor = color
        .SelBold = style And Bold
        .SelItalic = style And Italic
        .SelUnderline = style And Underline
        .SelFontName = IIf(style And Monospace, "Courier New", "Arial")
        .SelText = sText
        
    End With
    
End Sub
'

Private Sub AppendRichTextLn(sText As String, _
                            Optional color As Long = vbBlack, _
                            Optional style As RichStyles = Normal)
                            
    AppendRichText sText & vbNewLine, color, style
    
End Sub
'

' repozicioniranje kontrola u zavisnosti od velicine prozora
Private Sub Form_Resize()
    
    On Error Resume Next ' za slucaj da Width/Height odu ispod nule
    
    fRegExp.Move 100, 100, Me.ScaleWidth - 200, 2130
    fResults.Move 100, 2330, Me.ScaleWidth - 200, Me.ScaleHeight - 2430
    
    txtExpression.Move 1335, 405, fRegExp.Width - 1480
    txtSourceString.Move 1335, 825, fRegExp.Width - 1480
    txtReplaceWith.Move 1335, 1245, fRegExp.Width - 1480
    picActions.Move fRegExp.Width - 4585
    
    cmdClear.Move fResults.Width - 1180, fResults.Height - 430
    rtbResults.Move 100, 250, fResults.Width - 200, fResults.Height - 780
    
End Sub
'
